unit uTSearchEngineListItem;

interface

uses
 uSearchEngineGlobal;

type
 // TSearchEngineListItemType
 TSearchEngineListItemType = (selitNone, selitContent, selitImage, selitMaps);

 // TSearchEngineListItem
 TSearchEngineListItem = class
  ItemEnglishName: string;
  ItemGermanName: string;
  ItemSearchEngineURL: string;
  ItemType: TSearchEngineListItemType;
  ItemSearchEngineProvider: TSearchEngineProvider;
  ItemSearchEngineCode: integer;
  ItemWorldCode: integer;
  ItemCountryCode: integer;
  ItemCode: integer;
  ItemLargeIconIndex: integer;
  ItemSmallIconIndex: integer;
  ItemSelected: boolean;
 public
  constructor Create(SearchEngineProvider : TSearchEngineProvider);
 end;

implementation

{ TSearchEngineListItem }

constructor TSearchEngineListItem.Create(SearchEngineProvider : TSearchEngineProvider);
begin
 ItemSearchEngineURL := '';
 ItemType := selitNone;
 ItemSearchEngineCode := -1;
 ItemWorldCode := -1;
 ItemCountryCode := -1;
 ItemCode := -1;
 ItemLargeIconIndex := -1;
 ItemSmallIconIndex := -1;
 case SearchEngineProvider of
   sepNone:         begin
                     ItemEnglishName := '';
                     ItemGermanName := '';
                     ItemLargeIconIndex := -1;
                     ItemSmallIconIndex := -1;
                     ItemSearchEngineProvider := sepNone;
                    end;
   sepGoogle:       begin
                     ItemEnglishName := 'Google';
                     ItemGermanName := 'Google';
                     ItemLargeIconIndex := 255;
                     ItemSmallIconIndex := 256;
                     ItemSearchEngineProvider := sepGoogle;
                    end;
 end;
 ItemSelected := false;
end;

end.
