unit ufrmTestProject;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, AdvToolBar, AdvToolBarStylers, AdvPreviewMenu, AdvStyleIF,
  AdvPreviewMenuStylers, AdvShapeButton, AdvOfficeStatusBar, Math,
  AdvOfficeStatusBarStylers, System.Generics.Collections,
  AdvAppStyler, Vcl.StdCtrls, AdvGlowButton, Vcl.ExtCtrls, ShellAPI, AdvEdit,
  AdvEdBtn, AdvFileNameEdit, TlHelp32, System.IOUtils, AdvOfficePager,
  AdvOfficePagerStylers, Vcl.Mask, AdvSpin, Vcl.Imaging.pngimage, Vcl.ComCtrls, AdvListV,
  AdvScrollBox, AdvGroupBox,
  AdvOfficeButtons,  ShLwApi, TaskDialog, AdvSmoothSplashScreen, IdTCPClient,
  AdvPanel, AdvSplitter, AdvMemo, AdvCodeList, AdvCombo, AdvmWS, Vcl.Menus,
  AdvMenus, AdvTreeViewBase, AdvTreeViewData, AdvCustomTreeView, AdvTreeView,
  AdvDirectoryTreeView, PictureContainer, AdvSmoothListBox, AdvSmoothComboBox,
  AdvLabel, AdvCheckTreeView, AdvCheckedTreeView, StrUtils, AdvTypes,
  uSearchEngineList,
  uTCountryListItem,
  uTSearchEngineListItem,
  uTSearchEngineProviderListItem,
  uSearchEngineGlobal,
  AdvListBox, AdvUtil, Vcl.Grids, AdvObj, BaseGrid, AdvGrid, AdvCustomControl,
  GDIPPictureContainer;

type
  TfrmTestProject = class(TForm)
    tbpMainPager: TAdvOfficePager;
    pRankTrackingProgress: TAdvOfficePage;
    tbpRankTracking: TAdvOfficePager;
    pRTSearchEngines: TAdvOfficePage;
    pSearchEngineListBackPanel: TPanel;
    tvSearchEngineList: TAdvTreeView;
    pSearchEngineListTopPanel: TPanel;
    pSearchEnginesListTopPanel: TPanel;
    lblSearchEngineList: TLabel;
    cbSearchEngineListViewMode: TAdvComboBox;
    SearchEngineListPictureContainer: TPictureContainer;
    AdvOfficePage1: TAdvOfficePage;
    Memo1: TMemo;
    AdvGlowButton1: TAdvGlowButton;
    AdvOfficePagerOfficeStyler1: TAdvOfficePagerOfficeStyler;
    GDIPPictureContainer1: TGDIPPictureContainer;
    procedure FormShow(Sender: TObject);
    procedure cbSearchEngineListViewModeSelect(Sender: TObject);
    procedure tvSearchEngineListGetNodeIcon(Sender: TObject;
      ANode: TAdvTreeViewVirtualNode; AColumn: Integer; ALarge: Boolean;
      var AIcon: TAdvBitmap);
    procedure AdvGlowButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FBitmapList: TAdvScaledBitmaps;
  protected
    { Protected declarations }
  public
  end;

var
  frmTestProject: TfrmTestProject;

implementation

{$R *.dfm}

procedure TfrmTestProject.FormCreate(Sender: TObject);
begin
  FBitmapList := TAdvScaledBitmaps.Create(nil);
end;

procedure TfrmTestProject.FormDestroy(Sender: TObject);
begin
  FBitmapList.Free;
end;

procedure TfrmTestProject.FormShow(Sender: TObject);
begin
 // world data list
 cbSearchEngineListViewMode.ItemIndex := 0;
 cbSearchEngineListViewModeSelect(cbSearchEngineListViewMode);
end;

procedure TfrmTestProject.tvSearchEngineListGetNodeIcon(Sender: TObject;
  ANode: TAdvTreeViewVirtualNode; AColumn: Integer; ALarge: Boolean;
  var AIcon: TAdvBitmap);
var
  p: TAdvBitmap;
  it: PictureContainer.TPictureItem;
  b: TAdvScaledBitmap;

  function HasBitmap(ABitmapName: string; var ABitmap: TAdvBitmap): Boolean;
  var
    I: Integer;
  begin
    Result := False;
    for I := 0 to FBitmapList.Count - 1 do
    begin
      if FBitmapList[I].BitmapName = ABitmapName then
      begin
        ABitmap := FBitmapList[I].Bitmap;
        Result := True;
        Break;
      end;
    end;
  end;

begin
  it := nil;
  if ANode.Node.DataObject <> nil then
   if ANode.Node.DataObject.ClassName = 'TSearchEngineProviderListItem' then
   begin
    // TSearchEngineProviderListItem
    if TSearchEngineProviderListItem(ANode.Node.DataObject).ItemIconIndex <> -1 then
     if TSearchEngineProviderListItem(ANode.Node.DataObject).ItemIconIndex <= SearchEngineListPictureContainer.Items.Count - 1 then
      if Assigned(tvSearchEngineList.PictureContainer) then
        it := SearchEngineListPictureContainer.Items[TSearchEngineProviderListItem(ANode.Node.DataObject).ItemIconIndex];
   end else
   if ANode.Node.DataObject.ClassName = 'TCountryListItem' then
   begin
    // TCounryListItem
    if TCountryListItem(ANode.Node.DataObject).ItemIconIndex <> -1 then
     if TCountryListItem(ANode.Node.DataObject).ItemIconIndex <= SearchEngineListPictureContainer.Items.Count - 1 then
      if Assigned(tvSearchEngineList.PictureContainer) then
       it := SearchEngineListPictureContainer.Items[TCountryListItem(ANode.Node.DataObject).ItemIconIndex];
   end else
   if ANode.Node.DataObject.ClassName = 'TSearchEngineListItem' then
   begin
    // TSearchEngineListItem
  	if SearchEngineListObject.SearchEngineListViewMode <> selvmSearchEngineProvider then
     if ANode.Node.DataInteger <= SearchEngineListObject.SearchEngineDataList.Count - 1 then
      if TSearchEngineListItem(ANode.Node.DataObject).ItemLargeIconIndex <> -1 then
       if TSearchEngineListItem(ANode.Node.DataObject).ItemLargeIconIndex <= SearchEngineListPictureContainer.Items.Count - 1 then
        if Assigned(tvSearchEngineList.PictureContainer) then
         it := SearchEngineListPictureContainer.Items[TSearchEngineListItem(ANode.Node.DataObject).ItemLargeIconIndex]
	  else
	  if ANode.Node.DataInteger <= SearchEngineListObject.SearchEngineDataList.Count - 1 then
     if TSearchEngineListItem(ANode.Node.DataObject).ItemSmallIconIndex <> -1 then
      if TSearchEngineListItem(ANode.Node.DataObject).ItemSmallIconIndex <= SearchEngineListPictureContainer.Items.Count - 1 then
       if Assigned(tvSearchEngineList.PictureContainer) then
        it := SearchEngineListPictureContainer.Items[TSearchEngineListItem(ANode.Node.DataObject).ItemSmallIconIndex];
   end else
   begin
    ShowMessage(ANode.Node.DataObject.ClassName);
   end;

   if Assigned(it) then
   begin
     p := nil;
     if not HasBitmap(it.Name, p) then
     begin
       b := FBitmapList.AddBitmapName(it.Name);
       b.Bitmap.Assign(it.Picture);
       p := b.Bitmap;
     end;

    AIcon := p;
  end;
end;

procedure TfrmTestProject.cbSearchEngineListViewModeSelect(Sender: TObject);
begin
 // check if search engine list is loaded an valid
 if SearchEngineListObject = nil then
  SearchEngineListObject := TSearchEngineListObject.Create;
 // check if search engine list is loaded an valid
 if SearchEngineListObject <> nil then
 begin
  // change view depending on selected view mode
  case TAdvComboBox(Sender).ItemIndex of
   // search engine list grouped by search engine providers
   0 : begin
        SearchEngineListObject.DisplaySearchEnginesByProvider(tvSearchEngineList);
       end;
   // search engine list grouped by countries
   1 : begin
        SearchEngineListObject.DisplaySearchEnginesByCountry(tvSearchEngineList);
       end;
   // search engine list grouped by subcontinents
   2 : begin
        SearchEngineListObject.DisplaySearchEnginesBySubContinents(tvSearchEngineList);
       end;
   // search engine list grouped by continents
   3 : begin
        SearchEngineListObject.DisplaySearchEnginesByContinents(tvSearchEngineList);
       end;
  end;
 end;
end;

procedure TfrmTestProject.AdvGlowButton1Click(Sender: TObject);
var
 i: integer;
begin
 Memo1.Clear;
 Memo1.Lines.BeginUpdate;
 for i := 0 to SearchEngineListPictureContainer.Items.Count - 1 do
  Memo1.Lines.Add('Name: ' + SearchEngineListPictureContainer.Items[i].Name + ' | Width: ' + SearchEngineListPictureContainer.Items[i].Picture.Width.ToString + 'px | Height: ' + SearchEngineListPictureContainer.Items[i].Picture.Height.ToString + 'px');
 Memo1.Lines.EndUpdate;
end;

end.
